<script lang="ts">
  import type { KanbanTask } from '../../models/Kanban';
  import { Button, Modal, ModalBody } from '@sveltestrap/sveltestrap';
  import type { TeamUser } from '../../models/Team';
  import { updateTaskAssignee } from '../../models/Kanban.js';
  import UserBadgeAssign from './Task/UserBadgeAssign.svelte';

  // Use the ID so the modal is stable between subscription updates
  export let task_id: string | undefined = undefined;
  export let tasks: KanbanTask[] = [];

  let task: KanbanTask | undefined = undefined;
  $: task = tasks.find((t) => t.id == task_id);

  export let teammates: TeamUser[] = [];
  export let open = false;
  export let onClose: Function = () => {};
  let selectedUserId: string | undefined;
  let assigneeUserId: string | undefined;
  let assigneeUser: TeamUser | undefined;

  $: assigneeUserId = task?.assignee_id;
  $: assigneeUser = selectedUserId ? teammates.find((user) => user.id === assigneeUserId) : undefined;

  export function show(task_id_?: string) {
    if (task_id_) {
      task_id = task_id_;
    }
    open = true;
  }

  export function hide() {
    open = false;
    if (onClose) {
      onClose();
    }
  }

  export function toggle() {
    if (open) hide();
    else show();
  }

  async function unassign() {
    if (!task_id) {
      return;
    }
    await updateTaskAssignee(task_id, null);
    hide();
  }

  async function submit() {
    if (!task_id) {
      return;
    }
    await updateTaskAssignee(task_id, selectedUserId!);
    hide();
  }
</script>

<Modal isOpen={open} {toggle}>
  <div class="modal-header">
    <h5 class="modal-title w-100">
      Assign {task?.title}
    </h5>
  </div>
  <ModalBody>
    {#if assigneeUser}
      <UserBadgeAssign
        userId={assigneeUser.id}
        firstName={assigneeUser?.first_name}
        lastName={assigneeUser?.last_name}
        onClick={unassign}
        buttonText="Unassign"
      />
    {/if}
    <div class="d-flex flex-row align-items-center">
      <div class="flex-grow-1">
        <select bind:value={selectedUserId} class="form-select d-flex" aria-label="Default select example">
          {#each teammates as user}
            <option value={user.id}>{user.first_name} {user.last_name}</option>
          {/each}
        </select>
      </div>
      <div style="margin-left: 1em;"><Button color="primary" on:click={submit}>Assign Task</Button></div>
    </div>
  </ModalBody>
</Modal>
